USE AdventureWorks2008R2
GO
IF OBJECT_ID('usp_tt_SearchOrder') is not null 
drop procedure usp_tt_SearchOrder
GO
CREATE Procedure usp_tt_SearchOrder
@FromData Date,
@ToDate Date
AS	

-- filter out rows first
SELECT Soh.SalesOrderID
into #tmp_SalesOrderHeader
FROM Sales.SalesOrderHeader Soh
where Soh.OrderDate between @FromData and @ToDate

-- get only relevant records from other tables
SELECT 
	Pr.FirstName,
	Pr.LastName,
	Soh.SalesOrderNumber,
	Soh.SalesOrderID,
	Soh.TotalDue,
	Soh.Comment,
	Soh.Status,
	CC.CardType,
	Cust.AccountNumber
FROM 
#tmp_SalesOrderHeader tmp 
JOIN Sales.SalesOrderHeader Soh ON Soh.SalesOrderID=tmp.SalesOrderID
Join Sales.CreditCard CC ON CC.CreditCardID=Soh.CreditCardID
Left Join Sales.CurrencyRate CR ON CR.CurrencyRateID=Soh.CurrencyRateID
Join Sales.Customer Cust ON Cust.CustomerID=Soh.CustomerID
Join Person.Person Pr ON Pr.BusinessEntityID=Cust.PersonID
